#! /usr/bin/env node
"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var commander_1 = __importDefault(require("commander"));
var fs_1 = require("fs");
var qs_1 = __importDefault(require("qs"));
var open_1 = __importDefault(require("open"));
var path_1 = __importDefault(require("path"));
var ora_1 = __importDefault(require("ora"));
var inquirer_1 = __importDefault(require("inquirer"));
var temp_dir_1 = __importDefault(require("temp-dir"));
var is_expo_running_1 = __importDefault(require("./is-expo-running"));
var is_rn_running_1 = __importDefault(require("./is-rn-running"));
var request_resource_1 = require("./request-resource");
var is_cra_running_1 = __importDefault(require("./is-cra-running"));
var packageJson = require('../package.json');
var defaultDir = fs_1.mkdtempSync(path_1.default.join(temp_dir_1.default, 'npx-visualize-bundle'));
commander_1.default
    .version(packageJson.version, '-v, --version')
    .option('-a, --android', 'Analyse Android bundle ')
    .option('-d, --dev', 'Analyse development bundle')
    .option('-j, --json', 'Output JSON')
    .option('-o, --output [dir]', 'Specify output dir', defaultDir)
    .option('-p, --port [port]', 'Specify js package port')
    .parse(process.argv);
var sourceMapExplorer = require('source-map-explorer');
var platform = commander_1.default.android ? 'android' : 'ios';
var query = qs_1.default.stringify({
    platform: platform,
    sourceMap: 'true',
    dev: String(Boolean(commander_1.default.dev)),
    minify: String(!commander_1.default.dev),
    hot: 'false'
});
var start = function () { return __awaiter(_this, void 0, void 0, function () {
    var _a, expoRunning, rnRunning, craRunning, port, selectedProject, choices, prompt_1, project, startTime, spinner, bundlePairs, _loop_1, _i, _b, _c, index, bundlePair;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                console.log(' ');
                process.stdout.write('Searching for running React Native, Expo or CRA project... ');
                return [4 /*yield*/, Promise.all([
                        is_expo_running_1.default(query),
                        is_rn_running_1.default(commander_1.default.port || 8081, platform, query),
                        is_cra_running_1.default(commander_1.default.port || 3000)
                    ])];
            case 1:
                _a = _d.sent(), expoRunning = _a[0], rnRunning = _a[1], craRunning = _a[2];
                port = commander_1.default.port || (expoRunning ? 19001 : 8081);
                selectedProject = null;
                choices = [];
                if (rnRunning) {
                    console.log('Found React Native app.');
                    console.log('');
                    selectedProject = 'react-native';
                    choices.push({
                        value: 'react-native',
                        name: "React Native project running on port " + port
                    });
                }
                if (expoRunning) {
                    console.log('Found EXpo app.');
                    console.log('');
                    selectedProject = 'expo';
                    choices.push({
                        value: 'expo',
                        name: 'Expo project running on port 19001'
                    });
                }
                if (craRunning) {
                    console.log('Found create-react-app project.');
                    console.log('');
                    selectedProject = 'cra';
                    choices.push({
                        value: 'cra',
                        name: 'create-react-app running on port 3000'
                    });
                }
                if (!(choices.length > 0 && !commander_1.default.port)) return [3 /*break*/, 3];
                console.log('Multiple found.');
                prompt_1 = inquirer_1.default.createPromptModule();
                return [4 /*yield*/, prompt_1([
                        {
                            type: 'list',
                            name: 'project',
                            message: 'Found multiple projects. Which one would you like to analyze?',
                            choices: choices
                        }
                    ])];
            case 2:
                project = (_d.sent()).project;
                port =
                    project === 'cra'
                        ? commander_1.default.port || 3000
                        : project === 'rn'
                            ? commander_1.default.port || 8081
                            : commander_1.default.port || 19001;
                selectedProject = project;
                _d.label = 3;
            case 3:
                if (choices.length === 0) {
                    console.log('None found.');
                    console.log("Could not find a React Native, Expo, or create-react-app projet running on port " + 8081 + ", " + 19001 + " or " + 3000 + ". Start one and run 'npx visualize-bundle' again.");
                    console.log('');
                    process.exit(0);
                }
                startTime = Date.now();
                spinner = ora_1.default();
                spinner.start();
                spinner.text = "Getting bundle...";
                return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 100); })];
            case 4:
                _d.sent();
                bundlePairs = [];
                if (selectedProject === 'cra') {
                    bundlePairs = craRunning;
                }
                else if (selectedProject === 'expo') {
                    bundlePairs = expoRunning;
                }
                else if (selectedProject === 'react-native') {
                    bundlePairs = rnRunning;
                }
                _loop_1 = function (index, bundlePair) {
                    var bundleUrl, sourceMapUrl, bundle, sourceMap, outputDir_1, filename_1, analysis, endTime, err_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 9, , 10]);
                                bundleUrl = bundlePair[0], sourceMapUrl = bundlePair[1];
                                spinner.text = "(" + (Number(index) + 1) + "/" + bundlePairs.length + ") Getting bundle...";
                                return [4 /*yield*/, request_resource_1.getAnyResource([bundleUrl])];
                            case 1:
                                bundle = _a.sent();
                                spinner.text = "(" + (Number(index) + 1) + "/" + bundlePairs.length + ") Getting map...";
                                return [4 /*yield*/, request_resource_1.getAnyResource([sourceMapUrl])];
                            case 2:
                                sourceMap = _a.sent();
                                return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 100); })];
                            case 3:
                                _a.sent();
                                outputDir_1 = path_1.default.resolve(commander_1.default.output);
                                filename_1 = "bundle" + index;
                                fs_1.writeFileSync(path_1.default.join(outputDir_1, filename_1 + ".js"), bundle.body);
                                fs_1.writeFileSync(path_1.default.join(outputDir_1, filename_1 + ".js.map"), sourceMap.body);
                                spinner.text = 'Analysing bundle using source-map-explorer...';
                                return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 100); })];
                            case 4:
                                _a.sent();
                                analysis = sourceMapExplorer(path_1.default.join(outputDir_1, filename_1 + ".js"), path_1.default.join(outputDir_1, filename_1 + ".js.map"), { html: !commander_1.default.json });
                                if (!commander_1.default.json) return [3 /*break*/, 5];
                                fs_1.writeFileSync(path_1.default.join(outputDir_1, "report" + index + ".json"), JSON.stringify(__assign({}, analysis), null, 2));
                                console.log('');
                                console.log('');
                                console.log("\u2747\uFE0F  Written report as JSON to " + path_1.default.join(outputDir_1, "report" + index + ".json"));
                                return [3 /*break*/, 7];
                            case 5:
                                fs_1.writeFileSync(path_1.default.join(outputDir_1, "report" + index + ".html"), analysis.html);
                                endTime = Date.now();
                                return [4 /*yield*/, open_1.default(path_1.default.join(outputDir_1, "report" + index + ".html"))];
                            case 6:
                                _a.sent();
                                console.log(' ');
                                console.log("\u2747\uFE0F  Report generated in " + Math.floor((endTime - startTime) / 1000) + "s and opened in browser.");
                                console.log(' ');
                                _a.label = 7;
                            case 7: return [4 /*yield*/, new Promise(function (resolve) {
                                    fs_1.unlink(path_1.default.join(outputDir_1, filename_1 + "js"), function () {
                                        fs_1.unlink(path_1.default.join(outputDir_1, filename_1 + "js.map"), function () {
                                            resolve();
                                        });
                                    });
                                })];
                            case 8:
                                _a.sent();
                                return [3 /*break*/, 10];
                            case 9:
                                err_1 = _a.sent();
                                console.log('');
                                if (err_1.message.match(/500/)) {
                                    console.log([
                                        'The packager returned status code 500.',
                                        'Your code might have an error that will prevent it from compilation.',
                                        'Check the output of the packager.'
                                    ].join('\n'));
                                    process.exit(1);
                                }
                                else {
                                    //console.log('Could not do bundle analysis: ' + err.message);
                                    //console.log(err.stack);
                                }
                                return [3 /*break*/, 10];
                            case 10: return [2 /*return*/];
                        }
                    });
                };
                _i = 0, _b = Object.entries(bundlePairs);
                _d.label = 5;
            case 5:
                if (!(_i < _b.length)) return [3 /*break*/, 8];
                _c = _b[_i], index = _c[0], bundlePair = _c[1];
                return [5 /*yield**/, _loop_1(index, bundlePair)];
            case 6:
                _d.sent();
                _d.label = 7;
            case 7:
                _i++;
                return [3 /*break*/, 5];
            case 8:
                process.exit(0);
                return [2 /*return*/];
        }
    });
}); };
start();
